From 0cc60674798ea7cc6472917cc9440de26f599b6d Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Wed, 8 Feb 2012 12:47:30 -0600
Subject: Moved process into screen... element handles post

---
 grade/report/quick_edit/classes/datalib.php    |  163 ------------------------
 grade/report/quick_edit/classes/lib.php        |   91 ++++++++++++-
 grade/report/quick_edit/classes/uilib.php      |  122 ++++++++++++++++++
 grade/report/quick_edit/index.php              |   10 +-
 grade/report/quick_edit/lib.php                |    2 +-
 grade/report/quick_edit/screens/grade/lib.php  |   29 ++--
 grade/report/quick_edit/screens/select/lib.php |    5 +-
 grade/report/quick_edit/screens/user/lib.php   |   21 ++--
 8 files changed, 240 insertions(+), 203 deletions(-)
 delete mode 100644 grade/report/quick_edit/classes/datalib.php

diff --git a/grade/report/quick_edit/classes/lib.php b/grade/report/quick_edit/classes/lib.php
index 2172da0..1918612 100644
--- a/grade/report/quick_edit/classes/lib.php
+++ b/grade/report/quick_edit/classes/lib.php
@@ -1,7 +1,6 @@
 <?php
 
 require_once $CFG->dirroot . '/grade/report/quick_edit/classes/uilib.php';
-require_once $CFG->dirroot . '/grade/report/quick_edit/classes/datalib.php';
 
 interface selectable_items {
     public function description();
@@ -45,15 +44,15 @@ abstract class quick_edit_screen {
         }
     }
 
-    public function fetch_grade_or_default($item, $user) {
+    public function fetch_grade_or_default($item, $userid) {
         $grade = grade_grade::fetch(array(
-            'itemid' => $item->id, 'userid' => $user->id
+            'itemid' => $item->id, 'userid' => $userid
         ));
 
         if (!$grade) {
             $default = new stdClass;
 
-            $default->userid = $user->id;
+            $default->userid = $userid;
             $default->itemid = $item->id;
             $default->feedback = '';
 
@@ -114,8 +113,70 @@ abstract class quick_edit_screen {
         return $this->__factory;
     }
 
-    public function processor() {
-        return new quick_edit_grade_processor($this->courseid);
+    public function process($data) {
+        $warnings = array();
+
+        foreach ($data as $varname => $throw) {
+            if (preg_match("/(\w+)_(\d+)_(\d+)/", $varname, $matches)) {
+                $itemid = $matches[2];
+                $userid = $matches[3];
+            } else {
+                continue;
+            }
+
+            $fields = $this->definition();
+
+            if (!in_array($matches[1], $fields)) {
+                continue;
+            }
+
+            $grade_item = grade_item::fetch(array(
+                'id' => $itemid, 'courseid' => $this->courseid
+            ));
+
+            if (!$grade_item) {
+                continue;
+            }
+
+            $grade = $this->fetch_grade_or_default($grade_item, $userid);
+
+            $element = $this->factory()->create($matches[1])->format($grade);
+
+            $name = $element->get_name();
+            $oldname = "old$name";
+
+            $posted = $data->$name;
+            $oldvalue = $data->$oldname;
+
+            // Probably not supported
+            if (empty($data->$name) and empty($data->$oldname)) {
+                continue;
+            }
+
+            $format = $element->determine_format();
+
+            if ($format->is_textbox() and trim($data->$name) === '') {
+                $data->$name = null;
+            }
+
+            // Same value; skip
+            if ($oldvalue == $posted) {
+                continue;
+            }
+
+            $msg = $element->set($posted);
+
+            // Optional type
+            if (!empty($msg)) {
+                $warnings[] = $msg;
+            }
+        }
+
+        return $warnings;
+    }
+
+    public function definition() {
+        return array();
     }
 }
 
@@ -126,6 +187,20 @@ abstract class quick_edit_tablelike extends quick_edit_screen {
 
     public abstract function format_line($item);
 
+    public function format_definition($line, $grade) {
+        foreach ($this->definition() as $field) {
+            $html = $this->factory()->create($field)->format($grade);
+
+            if ($field == 'finalgrade') {
+                $html .= $this->structure->get_grade_analysis_icon($grade);
+            }
+
+            $line[] = $html;
+        }
+
+        return $line;
+    }
+
     public function html() {
         $table = new html_table();
 
@@ -149,7 +224,9 @@ abstract class quick_edit_tablelike extends quick_edit_screen {
     }
 
     public function buttons() {
-        $save = html_writer::empty_tag('input', array('type' => 'submit'));
+        $save = html_writer::empty_tag('input', array(
+            'type' => 'submit', 'value' => get_string('update')
+        ));
 
         return array($save);
     }
diff --git a/grade/report/quick_edit/classes/uilib.php b/grade/report/quick_edit/classes/uilib.php
index e36a0dc..8dd1cb4 100644
--- a/grade/report/quick_edit/classes/uilib.php
+++ b/grade/report/quick_edit/classes/uilib.php
@@ -33,6 +33,18 @@ abstract class quick_edit_ui_element {
         $this->value = $value;
     }
 
+    function is_checkbox() {
+        return false;
+    }
+
+    function is_textbox() {
+        return false;
+    }
+
+    function is_dropdown() {
+        return false;
+    }
+
     abstract function html();
 }
 
@@ -58,6 +70,10 @@ class quick_edit_text_attribute extends quick_edit_ui_element {
         parent::__construct($name, $value);
     }
 
+    function is_textbox() {
+        return true;
+    }
+
     function html() {
         $attributes = array(
             'type' => 'text',
@@ -90,6 +106,10 @@ class quick_edit_checkbox_attribute extends quick_edit_ui_element {
         parent::__construct($name, 1);
     }
 
+    function is_checkbox() {
+        return true;
+    }
+
     function html() {
         $attributes = array(
             'type' => 'checkbox',
@@ -97,6 +117,12 @@ class quick_edit_checkbox_attribute extends quick_edit_ui_element {
             'value' => 1
         );
 
+        $alt = array(
+            'type' => 'hidden',
+            'name' => $this->name,
+            'value' => 0
+        );
+
         $hidden = array(
             'type' => 'hidden',
             'name' => 'old' . $this->name
@@ -108,6 +134,7 @@ class quick_edit_checkbox_attribute extends quick_edit_ui_element {
         }
 
         return (
+            html_writer::empty_tag('input', $alt) .
             html_writer::empty_tag('input', $attributes) .
             html_writer::empty_tag('input', $hidden)
         );
@@ -132,6 +159,8 @@ abstract class quick_edit_grade_attribute_format extends quick_edit_attribute_fo
     function get_name() {
         return "{$this->name}_{$this->grade->itemid}_{$this->grade->userid}";
     }
+
+    public abstract function set($value);
 }
 
 interface unique_name {
@@ -174,6 +203,49 @@ class quick_edit_finalgrade_ui extends quick_edit_grade_attribute_format impleme
             $this->is_disabled()
         );
     }
+
+    function set($value) {
+        global $DB;
+
+        $userid = $this->grade->userid;
+        $grade_item = $this->grade->grade_item;
+
+        $feedback = false;
+        $feedbackformat = false;
+        if ($grade_item->gradetype == GRADE_TYPE_SCALE) {
+            if ($value == -1) {
+                $finalgrade = null;
+            } else {
+                $finalgrade = $value;
+            }
+        } else {
+            $finalgrade = unformat_float($value);
+        }
+
+        $errorstr = '';
+        if (is_null($finalgrade)) {
+            // ok
+        } else {
+            $bounded = $grade_item->bounded_grade($finalgrade);
+            if ($bounded > $finalgrade) {
+                $errorstr = 'lessthanmin';
+            } else if ($bounded < $finalgrade) {
+                $errorstr = 'morethanmax';
+            }
+        }
+
+        if ($errorstr) {
+            $user = $DB->get_record('user', array('id' => $userid), 'id, firstname, lastname');
+            $gradestr = new stdClass;
+            $gradestr->username = fullname($user);
+            $gradestr->itemname = $this->grade->grade_item->get_name();
+
+            $errorstr = get_string($errorstr, 'grades', $gradestr);
+        }
+
+        $grade_item->update_final_grade($userid, $finalgrade, 'quick_edit', $feedback, FORMAT_MOODLE);
+        return $errorstr;
+    }
 }
 
 class quick_edit_feedback_ui extends quick_edit_grade_attribute_format implements unique_value, be_disabled {
@@ -200,6 +272,22 @@ class quick_edit_feedback_ui extends quick_edit_grade_attribute_format implement
             $this->is_disabled()
         );
     }
+
+    function set($value) {
+        $finalgrade = false;
+        $trimmed = trim($value);
+        if (empty($trimmed)) {
+            $feedback = NULL;
+        } else {
+            $feedback = $value;
+        }
+
+        $this->grade->grade_item->update_final_grade(
+            $this->grade->userid, $finalgrade, 'quick_edit',
+            $feedback, FORMAT_MOODLE
+        );
+        return false;
+    }
 }
 
 class quick_edit_override_ui extends quick_edit_grade_attribute_format implements be_checked {
@@ -219,6 +307,18 @@ class quick_edit_override_ui extends quick_edit_grade_attribute_format implement
             $this->is_checked()
         );
     }
+
+    function set($value) {
+        if (empty($this->grade->id)) {
+            return false;
+        }
+
+        $state = $value == 0 ? false : true;
+
+        $this->grade->set_overridden($state);
+        $this->grade->grade_item->get_parent_category()->force_regrading();
+        return false;
+    }
 }
 
 class quick_edit_exclude_ui extends quick_edit_grade_attribute_format implements be_checked {
@@ -234,6 +334,28 @@ class quick_edit_exclude_ui extends quick_edit_grade_attribute_format implements
             $this->is_checked()
         );
     }
+
+    function set($value) {
+        if (empty($this->grade->id)) {
+            if (empty($value)) {
+                return false;
+            }
+
+            // Fill in arbitrary grade to be excluded
+            $this->grade->grade_item->update_final_grade(
+                $this->grade->userid, 0, 'quick_edit', null, FORMAT_MOODLE
+            );
+
+            $this->grade = grade_grade::fetch($grade_params);
+        }
+
+        $state = $value == 0 ? false : true;
+
+        $this->grade->set_excluded($state);
+
+        $this->grade->grade_item->get_parent_category()->force_regrading();
+        return false;
+    }
 }
 
 class quick_edit_range_ui extends quick_edit_attribute_format {
diff --git a/grade/report/quick_edit/index.php b/grade/report/quick_edit/index.php
index 667873c..034406a 100755
--- a/grade/report/quick_edit/index.php
+++ b/grade/report/quick_edit/index.php
@@ -90,11 +90,13 @@ print_grade_page_head($course->id, 'report', 'quick_edit', $reportname);
 
 if ($data = data_submitted()) {
     $warnings = $report->process_data($data);
-}
 
-if (!empty($warnings)) {
-    foreach ($warnings as $warning) {
-        echo $OUTPUT->notification($warning);
+    if (empty($warnings)) {
+        echo $OUTPUT->notification(get_string('changessaved'), 'notifysuccess');
+    } else {
+        foreach ($warnings as $warning) {
+            echo $OUTPUT->notification($warning);
+        }
     }
 }
 
diff --git a/grade/report/quick_edit/lib.php b/grade/report/quick_edit/lib.php
index 5076cbd..cb21d6c 100755
--- a/grade/report/quick_edit/lib.php
+++ b/grade/report/quick_edit/lib.php
@@ -63,7 +63,7 @@ class grade_report_quick_edit extends grade_report {
     }
 
     function process_data($data) {
-        return $this->screen->processor()->handle($data);
+        return $this->screen->process($data);
     }
 
     function process_action($target, $action) {
diff --git a/grade/report/quick_edit/screens/grade/lib.php b/grade/report/quick_edit/screens/grade/lib.php
index f16a1cd..a4f9ff1 100644
--- a/grade/report/quick_edit/screens/grade/lib.php
+++ b/grade/report/quick_edit/screens/grade/lib.php
@@ -4,7 +4,7 @@ class quick_edit_grade extends quick_edit_tablelike implements selectable_items
 
     private $requires_extra;
 
-    private $structure;
+    var $structure;
 
     public function description() {
         return get_string('users');
@@ -18,6 +18,16 @@ class quick_edit_grade extends quick_edit_tablelike implements selectable_items
         return 'user';
     }
 
+    public function definition() {
+        $def = array('finalgrade', 'feedback');
+
+        if ($this->requires_extra) {
+            $def[] = 'override';
+        }
+
+        return $def;
+    }
+
     public function init($self_item_is_empty = false) {
         $roleids = explode(',', get_config('moodle', 'gradebookroles'));
 
@@ -60,7 +70,7 @@ class quick_edit_grade extends quick_edit_tablelike implements selectable_items
     public function format_line($item) {
         global $OUTPUT;
 
-        $grade = $this->fetch_grade_or_default($this->item, $item);
+        $grade = $this->fetch_grade_or_default($this->item, $item->id);
 
         $fullname = fullname($item);
 
@@ -69,21 +79,10 @@ class quick_edit_grade extends quick_edit_tablelike implements selectable_items
         $line = array(
             $OUTPUT->user_picture($item),
             $this->format_link('user', $item->id, $fullname),
-            $this->item_range(),
-            $this->factory()->create('finalgrade')->format($grade) .
-            $this->structure->get_grade_analysis_icon($grade),
-            $this->factory()->create('feedback')->format($grade)
+            $this->item_range()
         );
 
-        return $this->additional_cells($line, $grade);
-    }
-
-    public function additional_cells($line, $grade) {
-        if ($this->requires_extra) {
-            $line[] = $this->factory()->create('override')->format($grade);
-        }
-
-        return $line;
+        return $this->format_definition($line, $grade);
     }
 
     public function additional_headers($headers) {
diff --git a/grade/report/quick_edit/screens/select/lib.php b/grade/report/quick_edit/screens/select/lib.php
index ec2c258..cb2c3f8 100644
--- a/grade/report/quick_edit/screens/select/lib.php
+++ b/grade/report/quick_edit/screens/select/lib.php
@@ -1,6 +1,5 @@
 <?php
 
-// TODO: custom form with group selector
 class quick_edit_select extends quick_edit_screen {
     public function init($self_item_is_empty = false) {
         global $DB;
@@ -16,13 +15,11 @@ class quick_edit_select extends quick_edit_screen {
         $types = grade_report_quick_edit::valid_screens();
 
         foreach ($types as $type) {
-            if ($type == 'select') continue;
-
             $class = grade_report_quick_edit::classname($type);
 
             $screen = new $class($this->courseid, null, $this->groupid);
 
-            if (!method_exists($screen, 'options')) {
+            if (!$screen instanceof selectable_items) {
                 continue;
             }
 
diff --git a/grade/report/quick_edit/screens/user/lib.php b/grade/report/quick_edit/screens/user/lib.php
index df24974..2da67e0 100644
--- a/grade/report/quick_edit/screens/user/lib.php
+++ b/grade/report/quick_edit/screens/user/lib.php
@@ -4,7 +4,7 @@ class quick_edit_user extends quick_edit_tablelike implements selectable_items {
 
     private $categories = array();
 
-    private $structure;
+    var $structure;
 
     public function description() {
         return get_string('gradeitems', 'grades');;
@@ -18,6 +18,12 @@ class quick_edit_user extends quick_edit_tablelike implements selectable_items {
         return 'grade';
     }
 
+    public function definition() {
+        return array(
+            'finalgrade', 'feedback', 'override', 'exclude'
+        );
+    }
+
     public function init($self_item_is_empty = false) {
         global $DB;
 
@@ -53,19 +59,16 @@ class quick_edit_user extends quick_edit_tablelike implements selectable_items {
     public function format_line($item) {
         global $OUTPUT;
 
-        $grade = $this->fetch_grade_or_default($item, $this->user);
+        $grade = $this->fetch_grade_or_default($item, $this->user->id);
 
-        return array(
+        $line = array(
             $this->format_icon($item),
             $this->format_link('grade', $item->id, $item->itemname),
             $this->category($item)->get_name(),
-            $this->factory()->create('range')->format($item),
-            $this->factory()->create('finalgrade')->format($grade) .
-            $this->structure->get_grade_analysis_icon($grade),
-            $this->factory()->create('feedback')->format($grade),
-            $this->factory()->create('override')->format($grade),
-            $this->factory()->create('exclude')->format($grade)
+            $this->factory()->create('range')->format($item)
         );
+
+        return $this->format_definition($line, $grade);
     }
 
     private function format_icon($item) {
-- 
1.7.1


